Index: pykota/trunk/pykota/loggers/__init__.py
===================================================================
--- pykota/trunk/pykota/loggers/__init__.py (revision 1144)
+++ pykota/trunk/pykota/loggers/__init__.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/loggers/stderr.py
===================================================================
--- pykota/trunk/pykota/loggers/stderr.py (revision 1144)
+++ pykota/trunk/pykota/loggers/stderr.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.5  2004/01/08 14:10:33  jalet
+# Copyright year changed.
+#
 # Revision 1.4  2003/10/07 09:07:29  jalet
 # Character encoding added to please latest version of Python
Index: pykota/trunk/pykota/loggers/system.py
===================================================================
--- pykota/trunk/pykota/loggers/system.py (revision 1144)
+++ pykota/trunk/pykota/loggers/system.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.9  2004/01/08 14:10:33  jalet
+# Copyright year changed.
+#
 # Revision 1.8  2003/10/07 09:07:29  jalet
 # Character encoding added to please latest version of Python
Index: pykota/trunk/pykota/requesters/snmp.py
===================================================================
--- pykota/trunk/pykota/requesters/snmp.py (revision 1144)
+++ pykota/trunk/pykota/requesters/snmp.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.13  2004/01/08 14:10:33  jalet
+# Copyright year changed.
+#
 # Revision 1.12  2003/10/07 09:07:29  jalet
 # Character encoding added to please latest version of Python
Index: pykota/trunk/pykota/requesters/__init__.py
===================================================================
--- pykota/trunk/pykota/requesters/__init__.py (revision 1144)
+++ pykota/trunk/pykota/requesters/__init__.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/requesters/external.py
===================================================================
--- pykota/trunk/pykota/requesters/external.py (revision 1144)
+++ pykota/trunk/pykota/requesters/external.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.10  2004/01/08 14:10:33  jalet
+# Copyright year changed.
+#
 # Revision 1.9  2003/10/07 09:07:29  jalet
 # Character encoding added to please latest version of Python
Index: pykota/trunk/pykota/tool.py
===================================================================
--- pykota/trunk/pykota/tool.py (revision 1248)
+++ pykota/trunk/pykota/tool.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.70  2004/01/08 14:10:32  jalet
+# Copyright year changed.
+#
 # Revision 1.69  2004/01/05 16:02:18  jalet
 # Dots in user, groups and printer names should be allowed.
@@ -290,5 +293,5 @@
 class PyKotaTool :    
     """Base class for all PyKota command line tools."""
-    def __init__(self, lang=None, doc="PyKota %s (c) 2003 %s" % (version.__version__, version.__author__)) :
+    def __init__(self, lang=None, doc="PyKota %s (c) 2003-2004 %s" % (version.__version__, version.__author__)) :
         """Initializes the command line tool."""
         # locale stuff
Index: pykota/trunk/pykota/reporters/__init__.py
===================================================================
--- pykota/trunk/pykota/reporters/__init__.py (revision 1144)
+++ pykota/trunk/pykota/reporters/__init__.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/reporters/html.py
===================================================================
--- pykota/trunk/pykota/reporters/html.py (revision 1251)
+++ pykota/trunk/pykota/reporters/html.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.5  2004/01/08 14:10:33  jalet
+# Copyright year changed.
+#
 # Revision 1.4  2004/01/06 15:51:46  jalet
 # Code factorization
Index: pykota/trunk/pykota/reporters/text.py
===================================================================
--- pykota/trunk/pykota/reporters/text.py (revision 1251)
+++ pykota/trunk/pykota/reporters/text.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.9  2004/01/08 14:10:33  jalet
+# Copyright year changed.
+#
 # Revision 1.8  2004/01/06 15:51:46  jalet
 # Code factorization
Index: pykota/trunk/pykota/__init__.py
===================================================================
--- pykota/trunk/pykota/__init__.py (revision 1144)
+++ pykota/trunk/pykota/__init__.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/accounters/stupid.py
===================================================================
--- pykota/trunk/pykota/accounters/stupid.py (revision 1240)
+++ pykota/trunk/pykota/accounters/stupid.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.11  2004/01/08 14:10:32  jalet
+# Copyright year changed.
+#
 # Revision 1.10  2003/12/27 16:49:25  uid67467
 # Should be ok now.
Index: pykota/trunk/pykota/accounters/__init__.py
===================================================================
--- pykota/trunk/pykota/accounters/__init__.py (revision 1144)
+++ pykota/trunk/pykota/accounters/__init__.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/accounters/external.py
===================================================================
--- pykota/trunk/pykota/accounters/external.py (revision 1240)
+++ pykota/trunk/pykota/accounters/external.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.13  2004/01/08 14:10:32  jalet
+# Copyright year changed.
+#
 # Revision 1.12  2003/12/27 16:49:25  uid67467
 # Should be ok now.
Index: pykota/trunk/pykota/accounters/querying.py
===================================================================
--- pykota/trunk/pykota/accounters/querying.py (revision 1240)
+++ pykota/trunk/pykota/accounters/querying.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.11  2004/01/08 14:10:32  jalet
+# Copyright year changed.
+#
 # Revision 1.10  2003/12/27 16:49:25  uid67467
 # Should be ok now.
Index: pykota/trunk/pykota/logger.py
===================================================================
--- pykota/trunk/pykota/logger.py (revision 1240)
+++ pykota/trunk/pykota/logger.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.12  2004/01/08 14:10:32  jalet
+# Copyright year changed.
+#
 # Revision 1.11  2003/12/27 16:49:25  uid67467
 # Should be ok now.
Index: pykota/trunk/pykota/requester.py
===================================================================
--- pykota/trunk/pykota/requester.py (revision 1240)
+++ pykota/trunk/pykota/requester.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.12  2004/01/08 14:10:32  jalet
+# Copyright year changed.
+#
 # Revision 1.11  2003/12/27 16:49:25  uid67467
 # Should be ok now.
Index: pykota/trunk/pykota/storages/pgstorage.py
===================================================================
--- pykota/trunk/pykota/storages/pgstorage.py (revision 1249)
+++ pykota/trunk/pykota/storages/pgstorage.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.28  2004/01/08 14:10:33  jalet
+# Copyright year changed.
+#
 # Revision 1.27  2004/01/06 14:24:59  jalet
 # Printer groups should be cached now, if caching is enabled.
Index: pykota/trunk/pykota/storages/__init__.py
===================================================================
--- pykota/trunk/pykota/storages/__init__.py (revision 1144)
+++ pykota/trunk/pykota/storages/__init__.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/storages/ldapstorage.py
===================================================================
--- pykota/trunk/pykota/storages/ldapstorage.py (revision 1249)
+++ pykota/trunk/pykota/storages/ldapstorage.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.44  2004/01/08 14:10:33  jalet
+# Copyright year changed.
+#
 # Revision 1.43  2004/01/06 14:24:59  jalet
 # Printer groups should be cached now, if caching is enabled.
Index: pykota/trunk/pykota/reporter.py
===================================================================
--- pykota/trunk/pykota/reporter.py (revision 1240)
+++ pykota/trunk/pykota/reporter.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.7  2004/01/08 14:10:32  jalet
+# Copyright year changed.
+#
 # Revision 1.6  2003/12/27 16:49:25  uid67467
 # Should be ok now.
Index: pykota/trunk/pykota/accounter.py
===================================================================
--- pykota/trunk/pykota/accounter.py (revision 1240)
+++ pykota/trunk/pykota/accounter.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.10  2004/01/08 14:10:32  jalet
+# Copyright year changed.
+#
 # Revision 1.9  2003/12/27 16:49:25  uid67467
 # Should be ok now.
Index: pykota/trunk/pykota/storage.py
===================================================================
--- pykota/trunk/pykota/storage.py (revision 1252)
+++ pykota/trunk/pykota/storage.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.33  2004/01/08 14:10:32  jalet
+# Copyright year changed.
+#
 # Revision 1.32  2004/01/06 16:02:57  jalet
 # This time printer groups caching works.
Index: pykota/trunk/pykota/config.py
===================================================================
--- pykota/trunk/pykota/config.py (revision 1227)
+++ pykota/trunk/pykota/config.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.42  2004/01/08 14:10:32  jalet
+# Copyright year changed.
+#
 # Revision 1.41  2003/11/29 20:06:20  jalet
 # Added 'utolower' configuration option to convert all usernames to
Index: pykota/trunk/pykota/version.py
===================================================================
--- pykota/trunk/pykota/version.py (revision 1248)
+++ pykota/trunk/pykota/version.py (revision 1257)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by