Index: pykota/trunk/docs/repykota.sgml
===================================================================
--- pykota/trunk/docs/repykota.sgml (revision 1166)
+++ pykota/trunk/docs/repykota.sgml (revision 1287)
@@ -90,4 +90,11 @@
     
     <para>
+      You may also want to copy the <acronym>CSS</acronym> stylesheets which are present in the
+      <filename>stylesheets/</filename> directory to your web server's <literal>DocumentRoot</literal>
+      (e.g. <filename>/var/lib/www</filename>) so that the CGI script can find them to present
+      a nicer web interface.
+    </para>
+    
+    <para>
       You can find <filename>printquota.cgi</filename> in the <filename>pykota/cgi-bin</filename>
       directory. Here's how to install it, provided that your web server's <filename>cgi-bin</filename>
@@ -145,4 +152,7 @@
 
 $Log$
+Revision 1.7  2004/01/12 23:10:35  jalet
+PyKota 1.16beta1 is finally out.
+
 Revision 1.6  2003/10/12 20:47:51  jalet
 Doc enhanced.
Index: pykota/trunk/pykota/version.py
===================================================================
--- pykota/trunk/pykota/version.py (revision 1285)
+++ pykota/trunk/pykota/version.py (revision 1287)
@@ -22,5 +22,5 @@
 #
 
-__version__ = "1.16alpha26_unofficial"
+__version__ = "1.16beta1_unofficial"
 
 __doc__ = """PyKota : a complete Printing Quota Solution for CUPS and LPRng."""
Index: pykota/trunk/MANIFEST.in
===================================================================
--- pykota/trunk/MANIFEST.in (revision 1279)
+++ pykota/trunk/MANIFEST.in (revision 1287)
@@ -1,5 +1,5 @@
 include README FAQ COPYING LICENSE TODO NEWS CREDITS SECURITY MANIFEST.in clean.sh bin/cupspykota bin/pykota bin/edpykota bin/warnpykota bin/repykota bin/pykotme bin/waitprinter.sh bin/papwaitprinter.sh bin/mailandpopup.sh bin/README
 recursive-include po README *.po *.mo *.pot
-recursive-include man README *.1
+recursive-include man README *.sh *.1
 recursive-include docs README *.sgml *.png *.pdf *.html
 recursive-include cgi-bin README *.cgi
Index: pykota/trunk/man/edpykota.1
===================================================================
--- pykota/trunk/man/edpykota.1 (revision 1167)
+++ pykota/trunk/man/edpykota.1 (revision 1287)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.33.
-.TH EDPYKOTA "1" "October 2003" "C@LL - Conseil Internet & Logiciels Libres" "PyKota Print Quota for CUPS and LPRng"
+.TH EDPYKOTA "1" "January 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-edpykota \- manual page for edpykota 1.15_unofficial
+edpykota \- manual page for edpykota 1.16beta1_unofficial
 .SH DESCRIPTION
-edpykota v1.15_unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
+edpykota v1.16beta1_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 A Print Quota editor for PyKota.
 .PP
@@ -51,6 +51,18 @@
 by separating them with commas.
 .TP
+\fB\-G\fR | \fB\-\-pgroups\fR pg1[,pg2...] Adds the printer(s) to the printer groups
+pg1, pg2, etc... which must already exist.
+A printer group is just like a normal printer,
+only that it is usually unknown from the printing
+system. Create printer groups exactly the same
+way that you create printers, then add other
+printers to them with this option.
+Accounting is done on a printer and on all
+the printer groups it belongs to, quota checking
+is done on a printer and on all the printer groups
+it belongs to.
+.TP
 \fB\-g\fR | \fB\-\-groups\fR
-Edit groups print quotas instead of users.
+Edit users groups print quotas instead of users.
 .TP
 \fB\-p\fR | \fB\-\-prototype\fR u|g Uses user u or group g as a prototype to set
@@ -92,8 +104,10 @@
 examples :
 .IP
-\f(CW$ edpykota -p jerome john paul george ringo\fR
+\f(CW$ edpykota --add -p jerome john paul george ringo/ringo@yourdomain.com\fR
 .IP
-This will set print quotas for the users john, paul, george and ringo
-to the same values than user jerome. User jerome must exist.
+This will add users john, paul, george and ringo to the quota
+database, and set their print quotas to the same values than user
+jerome. User jerome must already exist.
+User ringo's email address will also be set to 'ringo@yourdomain.com'
 .IP
 \f(CW$ edpykota --printer lp -S 50 -H 60 jerome\fR
@@ -109,11 +123,4 @@
 user jerome is put into the groups "coders" and "it" which must
 already exist in the Quota Storage.
-WARNING : the CUPS PPD file for this printer or the /etc/printcap
-.TP
-file (depending on your printing backend)
-must still be
-.IP
-modified manually, as well as pykota's configuration file
-for a new printer to be managed successfully.
 .IP
 \f(CW$ edpykota -g -S 500 -H 550 financial support\fR
@@ -155,4 +162,10 @@
 This will set the page price for printer lp to 0.1. Job price
 will not be changed.
+.IP
+\f(CW$ edpykota --printer hplj1,hplj2 --pgroups Laser,HP\fR
+.IP
+This will put printers hplj1 and hplj2 in printers groups Laser and HP.
+When printing either on hplj1 or hplj2, print quota will also be
+checked and accounted for on virtual printers Laser and HP.
 .PP
 This program is free software; you can redistribute it and/or modify
@@ -171,14 +184,2 @@
 .PP
 Please e-mail bugs to: Jerome Alet - alet@librelogiciel.com
-.SH "SEE ALSO"
-The full documentation for
-.B edpykota
-is maintained as a Texinfo manual.  If the
-.B info
-and
-.B edpykota
-programs are properly installed at your site, the command
-.IP
-.B info edpykota
-.PP
-should give you access to the complete manual.
Index: pykota/trunk/man/pykotme.1
===================================================================
--- pykota/trunk/man/pykotme.1 (revision 1167)
+++ pykota/trunk/man/pykotme.1 (revision 1287)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.33.
-.TH PYKOTME "1" "October 2003" "C@LL - Conseil Internet & Logiciels Libres" "PyKota Print Quota for CUPS and LPRng"
+.TH PYKOTME "1" "January 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-pykotme \- manual page for pykotme 1.15_unofficial
+pykotme \- manual page for pykotme 1.16beta1_unofficial
 .SH DESCRIPTION
-pykotme v1.15_unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
+pykotme v1.16beta1_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Gives print quotes to users.
@@ -65,14 +65,2 @@
 .PP
 Please e-mail bugs to: Jerome Alet - alet@librelogiciel.com
-.SH "SEE ALSO"
-The full documentation for
-.B pykotme
-is maintained as a Texinfo manual.  If the
-.B info
-and
-.B pykotme
-programs are properly installed at your site, the command
-.IP
-.B info pykotme
-.PP
-should give you access to the complete manual.
Index: pykota/trunk/man/repykota.1
===================================================================
--- pykota/trunk/man/repykota.1 (revision 1167)
+++ pykota/trunk/man/repykota.1 (revision 1287)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.33.
-.TH REPYKOTA "1" "October 2003" "C@LL - Conseil Internet & Logiciels Libres" "PyKota Print Quota for CUPS and LPRng"
+.TH REPYKOTA "1" "January 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-repykota \- manual page for repykota 1.15_unofficial
+repykota \- manual page for repykota 1.16beta1_unofficial
 .SH DESCRIPTION
-repykota v1.15_unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
+repykota v1.16beta1_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Generates print quota reports.
@@ -70,14 +70,2 @@
 .PP
 Please e-mail bugs to: Jerome Alet - alet@librelogiciel.com
-.SH "SEE ALSO"
-The full documentation for
-.B repykota
-is maintained as a Texinfo manual.  If the
-.B info
-and
-.B repykota
-programs are properly installed at your site, the command
-.IP
-.B info repykota
-.PP
-should give you access to the complete manual.
Index: pykota/trunk/man/genman.sh
===================================================================
--- pykota/trunk/man/genman.sh (revision 1287)
+++ pykota/trunk/man/genman.sh (revision 1287)
@@ -0,0 +1,18 @@
+#! /bin/sh
+#
+# PyKota - Print Quotas for CUPS and LPRng
+#
+# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# You're welcome to redistribute this software under the
+# terms of the GNU General Public Licence version 2.0
+# or, at your option, any higher version.
+#
+# You can read the complete GNU GPL in the file COPYING
+# which should come along with this software, or visit
+# the Free Software Foundation's WEB site http://www.fsf.org
+#
+# $Id$
+#
+for prog in edpykota pykotme repykota warnpykota ; do 
+    help2man --section=1 --manual "User Commands" --source="C@LL - Conseil Internet & Logiciels Libres" --output=$prog.1 --no-info $prog ; 
+done
Index: pykota/trunk/man/warnpykota.1
===================================================================
--- pykota/trunk/man/warnpykota.1 (revision 1167)
+++ pykota/trunk/man/warnpykota.1 (revision 1287)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.33.
-.TH WARNPYKOTA "1" "October 2003" "C@LL - Conseil Internet & Logiciels Libres" "PyKota Print Quota for CUPS and LPRng"
+.TH WARNPYKOTA "1" "January 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-warnpykota \- manual page for warnpykota 1.15_unofficial
+warnpykota \- manual page for warnpykota 1.16beta1_unofficial
 .SH DESCRIPTION
-warnpykota v1.15_unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
+warnpykota v1.16beta1_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Sends mail to users over print quota.
@@ -75,14 +75,2 @@
 .PP
 Please e-mail bugs to: Jerome Alet - alet@librelogiciel.com
-.SH "SEE ALSO"
-The full documentation for
-.B warnpykota
-is maintained as a Texinfo manual.  If the
-.B info
-and
-.B warnpykota
-programs are properly installed at your site, the command
-.IP
-.B info warnpykota
-.PP
-should give you access to the complete manual.
Index: pykota/trunk/NEWS
===================================================================
--- pykota/trunk/NEWS (revision 1286)
+++ pykota/trunk/NEWS (revision 1287)
@@ -22,4 +22,8 @@
 PyKota NEWS :
 
+    - 1.16beta1 :
+    
+        - Manpages upgraded.
+        
     - 1.16alpha26 :
     