Index: pykota/trunk/po/pykota.pot
===================================================================
--- pykota/trunk/po/pykota.pot (revision 1257)
+++ pykota/trunk/po/pykota.pot (revision 1295)
@@ -20,226 +20,212 @@
 # $Id$
 #
-# $Log$
-# Revision 1.39  2004/01/08 14:10:32  jalet
-# Copyright year changed.
-#
-# Revision 1.38  2003/12/27 16:49:25  uid67467
-# Should be ok now.
-#
-# Revision 1.36  2003/11/18 23:43:11  jalet
-# Mailto can be any external command now, as usual.
-#
-# Revision 1.35  2003/10/08 21:41:38  jalet
-# External policies for printers works !
-# We can now auto-add users on first print, and do other useful things if needed.
-#
-# Revision 1.34  2003/08/18 16:20:59  jalet
-# Improvement of the printing system detection code.
-#
-# Revision 1.33  2003/07/25 10:41:30  jalet
-# Better documentation.
-# pykotme now displays the current user's account balance.
-# Some test changed in ldap module.
-#
-# Revision 1.32  2003/07/21 23:01:55  jalet
-# Modified some messages aout soft limit
-#
-# Revision 1.31  2003/07/08 19:43:50  jalet
-# Configurable warning messages.
-# Poor man's treshold value added.
-#
-# Revision 1.30  2003/07/03 11:38:43  jalet
-# Translations for pykotme added
-#
-# Revision 1.29  2003/06/30 21:44:18  jalet
-# 1.09 is out !
-#
-# Revision 1.28  2003/06/25 10:39:17  jalet
-# Translations.
-#
-# Revision 1.27  2003/06/24 21:54:24  jalet
-# More translations.
-#
-# Revision 1.26  2003/06/24 14:53:04  jalet
-# More translations
-#
-# Revision 1.25  2003/06/15 22:26:52  jalet
-# More work on LDAP
-#
-# Revision 1.24  2003/04/30 19:53:58  jalet
-# 1.05
-#
-# Revision 1.23  2003/04/30 13:36:40  jalet
-# Stupid accounting method was added.
-#
-# Revision 1.22  2003/04/29 18:37:54  jalet
-# Pluggable accounting methods (actually doesn't support external scripts)
-#
-# Revision 1.21  2003/04/23 22:13:56  jalet
-# Preliminary support for LPRng added BUT STILL UNTESTED.
-#
-# Revision 1.20  2003/04/23 09:58:17  jalet
-# Prices per page/job are now displayed
-#
-# Revision 1.19  2003/04/17 09:26:21  jalet
-# repykota now reports account balances too.
-#
-# Revision 1.18  2003/04/16 12:35:49  jalet
-# Groups quota work now !
-#
-# Revision 1.17  2003/04/16 08:53:14  jalet
-# Printing can now be limited either by user's account balance or by
-# page quota (the default). Quota report doesn't include account balance
-# yet, though.
-#
-# Revision 1.16  2003/04/16 08:22:09  jalet
-# More strict error detection.
-# Minor code rewrite to avoid some repetitive tests.
-#
-# Revision 1.15  2003/04/16 08:01:54  jalet
-# edpykota --charge command line option works now.
-#
-# Revision 1.14  2003/04/11 14:42:54  jalet
-# Translations
-#
-# Revision 1.13  2003/04/09 23:20:38  jalet
-# A message added.
-#
-# Revision 1.12  2003/03/29 13:45:27  jalet
-# GPL paragraphs were incorrectly (from memory) copied into the sources.
-# Two README files were added.
-# Upgrade script for PostgreSQL pre 1.01 schema was added.
-#
-# Revision 1.11  2003/03/29 13:08:28  jalet
-# Configuration is now expected to be found in /etc/pykota.conf instead of
-# in /etc/cups/pykota.conf
-# Installation script can move old config files to the new location if needed.
-# Better error handling if configuration file is absent.
-#
-# Revision 1.10  2003/03/15 23:01:28  jalet
-# New mailto option in configuration file added.
-# No time to test this tonight (although it should work).
-#
-# Revision 1.9  2003/03/09 23:38:43  jalet
-# Simplified translations.
-#
-# Revision 1.8  2003/02/27 09:08:39  jalet
-# Updated translations.
-#
-# Revision 1.7  2003/02/10 12:12:08  jalet
-# Translation added for total number of pages for printer in repykota
-#
-# Revision 1.6  2003/02/10 11:49:06  jalet
-# Added Content-Transfert-Encoding
-#
-# Revision 1.5  2003/02/10 08:50:45  jalet
-# External requester seems to be finally ok now
-#
-# Revision 1.4  2003/02/10 00:42:17  jalet
-# External requester should be ok (untested)
-# New syntax for configuration file wrt requesters
-#
-# Revision 1.3  2003/02/09 14:02:31  jalet
-# French translation was added
-#
-# Revision 1.2  2003/02/09 13:10:46  jalet
-# Strings were extracted
-#
-# Revision 1.1  2003/02/05 21:28:17  jalet
-# Initial import into CVS
-#
-#
-#
 # PyKota translation master file.
-# Copyright (C) 2003 Conseil Internet & Logiciels Libres
-# Jerome Alet <alet@librelogiciel.com>, 2003.
-#
-msgid ""
-msgstr ""
-"Project-Id-Version: PyKota v0.9-unofficial\n"
-"POT-Creation-Date: Sun Feb  9 13:50:50 2003\n"
-"PO-Revision-Date: 2003-02-09 14:08+1\n"
+# Copyright (c) 2003-2004 Conseil Internet & Logiciels Libres
+# Jerome Alet <alet@librelogiciel.com>, 2003-2004.
+#
+#, fuzzy
+msgid ""
+msgstr ""
+"Project-Id-Version: PyKota v1.16\n"
+"Report-Msgid-Bugs-To: alet@librelogiciel.com\n"
+"POT-Creation-Date: 2004-01-15 11:51+0100\n"
+"PO-Revision-Date: 2004-01-15 12:00+0100\n"
 "Last-Translator: Jerome Alet <alet@librelogiciel.com>\n"
 "Language-Team: English <alet@librelogiciel.com>\n"
 "MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=ISO-8859-1\n"
+"Content-Type: text/plain; charset=ISO-8859-15\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: pygettext.py 1.3\n"
-
+
+#, python-format
+msgid "SIGTERM received, job %s cancelled."
+msgstr ""
+
+#, python-format
+msgid "SIGTERM was sent to real backend %s (pid: %s)"
+msgstr ""
+
+#, python-format
+msgid "CUPS backend %s died abnormally."
+msgstr ""
+
+#, python-format
+msgid "Invalid softlimit value %s."
+msgstr ""
+
+#, python-format
+msgid "Invalid hardlimit value %s."
+msgstr ""
+
+#, python-format
+msgid "Hard limit %i is less than soft limit %i, values will be exchanged."
+msgstr ""
+
+#, python-format
+msgid "Invalid balance value %s"
+msgstr ""
+
+#, python-format
+msgid "Invalid charge amount value %s"
+msgstr ""
+
+#, python-format
+msgid "Invalid limitby value %s"
+msgstr ""
+
+#, python-format
+msgid "Impossible to add printer %s"
+msgstr ""
+
+#, python-format
+msgid "Invalid printer name %s"
+msgstr ""
+
+#, python-format
+msgid "There's no printer matching %s"
+msgstr ""
+
+msgid "You have to pass user or group names on the command line"
+msgstr ""
+
+#, python-format
+msgid "Prototype %s not found in Quota Storage for printer %s."
+msgstr ""
+
+#, python-format
+msgid "Prototype object %s not found in Quota Storage."
+msgstr ""
+
+#, python-format
+msgid "Undefined hard limit set to soft limit (%s) on printer %s."
+msgstr ""
+
+#, python-format
 msgid "Undefined soft limit set to hard limit (%s) on printer %s."
 msgstr ""
 
-msgid "Hard limit %i is less than soft limit %i, values will be exchanged."
-msgstr ""
-
-msgid "Pages grace time: %i days"
-msgstr ""
-
-msgid "Invalid softlimit value %s."
-msgstr ""
-
-msgid "Prototype %s not found in Quota Storage for printer %s."
-msgstr ""
-
+#, python-format
+msgid "Invalid email address %s"
+msgstr ""
+
+#, python-format
+msgid "Invalid group name %s"
+msgstr ""
+
+#, python-format
+msgid "Invalid user name %s"
+msgstr ""
+
+#, python-format
+msgid "Quota not found for object %s on printer %s."
+msgstr ""
+
+#, python-format
+msgid "Group %s not found in the PyKota Storage."
+msgstr ""
+
+msgid "incompatible options, see help."
+msgstr ""
+
+#, python-format
 msgid "Printer %s not registered in the PyKota system"
 msgstr ""
 
-msgid "option --groups is currently not implemented."
-msgstr ""
-
-msgid "Quota not found for object %s on printer %s."
-msgstr ""
-
-msgid "Invalid user name %s"
-msgstr ""
-
-msgid "Both hard and soft limits must be set ! Aborting."
-msgstr ""
-
-msgid "Undefined hard limit set to soft limit (%s) on printer %s."
-msgstr ""
-
-msgid "incompatible options, see help."
-msgstr ""
-
-msgid "Invalid hardlimit value %s."
-msgstr ""
-
-msgid "Group           used    soft    hard    balance grace         total       paid"
-msgstr ""
-
-msgid "There's no printer matching %s"
-msgstr ""
-
-msgid "Report for %s quota on printer %s"
-msgstr ""
-
-msgid "Error in page count value %i for user %s on printer %s"
-msgstr ""
-
-msgid "Invalid group name %s"
-msgstr ""
-
-msgid "User            used    soft    hard    balance grace         total       paid"
-msgstr ""
-
-msgid "Invalid printer name %s"
-msgstr ""
-
+#, python-format
+msgid "Printer %s was never used"
+msgstr ""
+
+#, python-format
+msgid "Unable to compute size of %s in number of pages.\n"
+msgstr ""
+
+#, python-format
+msgid "Your account balance : %.2f"
+msgstr ""
+
+#, python-format
+msgid "Job size : %i pages"
+msgstr ""
+
+#, python-format
+msgid "Cost on printer %s : %.2f"
+msgstr ""
+
+#, python-format
+msgid "Unsupported accounter backend %s"
+msgstr ""
+
+#, python-format
+msgid "Configuration file %s not found."
+msgstr ""
+
+#, python-format
+msgid "Option %s not found in section global of %s"
+msgstr ""
+
+#, python-format
+msgid "Option %s not found in section %s of %s"
+msgstr ""
+
+#, python-format
+msgid "Option logger only supports values in %s"
+msgstr ""
+
+#, python-format
+msgid "Invalid external accounter %s for printer %s"
+msgstr ""
+
+#, python-format
+msgid "Option accounter in section %s only supports values in %s"
+msgstr ""
+
+#, python-format
+msgid "Option requester for printer %s was not set"
+msgstr ""
+
+#, python-format
+msgid "Invalid requester %s for printer %s"
+msgstr ""
+
+#, python-format
 msgid "Option requester for printer %s only supports values in %s"
 msgstr ""
 
-msgid "Print Quota Exceeded"
-msgstr ""
-
-msgid "Print Quota"
-msgstr ""
-
-msgid "Requester not implemented yet."
-msgstr ""
-
-msgid "Option %s not found in section %s of %s"
-msgstr ""
-
+#, python-format
+msgid "Invalid policy %s for printer %s"
+msgstr ""
+
+#, python-format
+msgid "Option policy in section %s only supports values in %s"
+msgstr ""
+
+#, python-format
+msgid "Invalid option mailto %s for printer %s"
+msgstr ""
+
+#, python-format
+msgid "Option mailto in section %s only supports values in %s"
+msgstr ""
+
+#, python-format
+msgid "Invalid grace delay %s"
+msgstr ""
+
+#, python-format
+msgid "Invalid poor man's treshold %s"
+msgstr ""
+
+msgid ""
+"Your Print Quota account balance is Low.\n"
+"Soon you'll not be allowed to print anymore.\n"
+"Please contact the Print Quota Administrator to solve the problem."
+msgstr ""
+
+#, python-format
+msgid ""
+"You are not allowed to print anymore because\n"
+"your Print Quota is exceeded on printer %s."
+msgstr ""
+
+#, python-format
 msgid ""
 "You will soon be forbidden to print anymore because\n"
@@ -247,4 +233,62 @@
 msgstr ""
 
+#, python-format
+msgid "Unsupported logging subsystem %s"
+msgstr ""
+
+#, python-format
+msgid "Report for %s quota on printer %s"
+msgstr ""
+
+#, python-format
+msgid "Pages grace time: %i days"
+msgstr ""
+
+#, python-format
+msgid "Price per job: %.3f"
+msgstr ""
+
+#, python-format
+msgid "Price per page: %.3f"
+msgstr ""
+
+msgid ""
+"Group           used    soft    hard    balance grace         total       "
+"paid"
+msgstr ""
+
+msgid ""
+"User            used    soft    hard    balance grace         total       "
+"paid"
+msgstr ""
+
+msgid "unknown"
+msgstr ""
+
+#, python-format
+msgid "Real : %s"
+msgstr ""
+
+#, python-format
+msgid "Total : %9i"
+msgstr ""
+
+#, python-format
+msgid "Unsupported reporter backend %s"
+msgstr ""
+
+#, python-format
+msgid "Unsupported requester backend %s"
+msgstr ""
+
+#, python-format
+msgid "Unsupported quota storage backend %s"
+msgstr ""
+
+#, python-format
+msgid "Impossible to send mail to %s, error %s : %s"
+msgstr ""
+
+#, python-format
 msgid ""
 "\n"
@@ -255,202 +299,143 @@
 msgstr ""
 
-msgid "Invalid grace delay %s"
-msgstr ""
-
-msgid "Option logger only supports values in %s"
-msgstr ""
-
-msgid "Option %s not found in section global of %s"
-msgstr ""
-
-msgid "Option method only supports values in %s"
-msgstr ""
-
+#, python-format
+msgid ""
+"Unable to find user %s's account balance, applying default policy (%s) for "
+"printer %s"
+msgstr ""
+
+#, python-format
 msgid "Unable to match user %s on printer %s, applying default policy (%s)"
 msgstr ""
 
-msgid "Group quotas are currently not implemented."
-msgstr ""
-
+#, python-format
+msgid "Print Quota exceeded for group %s on printer %s"
+msgstr ""
+
+msgid "Print Quota"
+msgstr ""
+
+msgid "Print Quota Exceeded"
+msgstr ""
+
+#, python-format
+msgid "Print Quota low for group %s on printer %s"
+msgstr ""
+
+#, python-format
+msgid "Print Quota exceeded for user %s on printer %s"
+msgstr ""
+
+#, python-format
+msgid "Print Quota low for user %s on printer %s"
+msgstr ""
+
+msgid "Print Quota Low"
+msgstr ""
+
+msgid "Printer hostname undefined, set to 'localhost'"
+msgstr ""
+
+#, python-format
+msgid "Printing system unknown, args=%s"
+msgstr ""
+
+#, python-format
+msgid ""
+"Printer %s not registered in the PyKota system, applying external policy (%"
+"s) for printer %s"
+msgstr ""
+
+#, python-format
+msgid ""
+"User %s not registered in the PyKota system, applying external policy (%s) "
+"for printer %s"
+msgstr ""
+
+#, python-format
+msgid ""
+"User %s doesn't have quota on printer %s in the PyKota system, applying "
+"external policy (%s) for printer %s"
+msgstr ""
+
+#, python-format
+msgid ""
+"External policy %s for printer %s produced an error. Job rejected. Please "
+"check PyKota's configuration files."
+msgstr ""
+
+#, python-format
+msgid ""
+"Printer %s not registered in the PyKota system, applying default policy (%s)"
+msgstr ""
+
+#, python-format
+msgid ""
+"User %s not registered in the PyKota system, applying default policy (%s) "
+"for printer %s"
+msgstr ""
+
+#, python-format
+msgid ""
+"User %s doesn't have quota on printer %s in the PyKota system, applying "
+"default policy (%s)"
+msgstr ""
+
+#, python-format
+msgid ""
+"Printer %s still not registered in the PyKota system, job will be rejected"
+msgstr ""
+
+#, python-format
+msgid ""
+"User %s still not registered in the PyKota system, job will be rejected on "
+"printer %s"
+msgstr ""
+
+#, python-format
+msgid ""
+"User %s still doesn't have quota on printer %s in the PyKota system, job "
+"will be rejected"
+msgstr ""
+
+#, python-format
+msgid "Unable to compute job size with external accounter %s"
+msgstr ""
+
+msgid "Using the 'stupid' accounting method is unreliable."
+msgstr ""
+
+msgid "Totals may be inaccurate if some users are members of several groups."
+msgstr ""
+
+#, python-format
+msgid "Unknown printer address in EXTERNAL(%s) for printer %s"
+msgstr ""
+
+#, python-format
+msgid "Unable to query printer %s via EXTERNAL(%s)"
+msgstr ""
+
+#, python-format
 msgid "Unknown printer address in SNMP(%s, %s) for printer %s"
 msgstr ""
 
-msgid "Print Quota low for user %s on printer %s"
-msgstr ""
-
-msgid "Unsupported logging subsystem %s"
-msgstr ""
-
+#, python-format
 msgid "Unable to query printer %s via SNMP(%s, %s)"
 msgstr ""
 
-msgid "Unsupported requester backend %s"
-msgstr ""
-
-msgid "Option policy in section %s only supports values in %s"
-msgstr ""
-
-msgid "Unsupported quota storage backend %s"
-msgstr ""
-
-msgid ""
-"You are not allowed to print anymore because\n"
-"your Print Quota is exceeded on printer %s."
-msgstr ""
-
-msgid "Print Quota exceeded for user %s on printer %s"
-msgstr ""
-
-msgid "Invalid requester %s for printer %s"
-msgstr ""
-
-msgid "Unknown printer address in EXTERNAL(%s) for printer %s"
-msgstr ""
-
-msgid "Unable to query printer %s via EXTERNAL(%s)"
-msgstr ""
-
-msgid "Total : %9i"
-msgstr ""
-
-msgid "Real : %s"
-msgstr ""
-
-msgid "You have to pass user or group names on the command line"
-msgstr ""
-
-msgid "unknown"
-msgstr ""
-
-msgid "Option mailto in section %s only supports values in %s"
-msgstr ""
-
-msgid "Configuration file %s not found."
-msgstr ""
-
-msgid "User %s not registered in the PyKota system, applying default policy (%s) for printer %s"
-msgstr ""
-
-msgid "Invalid charge amount value %s"
-msgstr ""
-
-msgid "Invalid balance value %s"
-msgstr ""
-
-msgid "Invalid limitby value %s"
-msgstr ""
-
-msgid "Unable to find user %s's account balance, applying default policy (%s) for printer %s"
-msgstr ""
-
-msgid "Unable to find group %s's account balance, applying default policy (%s) for printer %s"
-msgstr ""
-
-msgid "Unable to match group %s on printer %s, applying default policy (%s)"
-msgstr ""
-
-msgid "Print Quota exceeded for group %s on printer %s"
-msgstr ""
-
-msgid "Print Quota low for group %s on printer %s"
-msgstr ""
-
-msgid "Totals may be inaccurate if some users are members of several groups."
-msgstr ""
-
-msgid "Price per job: %.3f"
-msgstr ""
-
-msgid "Price per page: %.3f"
-msgstr ""
-
-msgid "Group %s not found in the PyKota Storage."
-msgstr ""
-
-msgid "Unsupported accounter backend %s"
-msgstr ""
-
-msgid "Option accounter in section %s only supports values in %s"
-msgstr ""
-
-msgid "Option requester for printer %s was not set"
-msgstr ""
-
-msgid "Using the 'stupid' accounting method is unreliable."
-msgstr ""
-
-msgid "Invalid external accounter %s for printer %s"
-msgstr ""
-
-msgid "Unable to compute job size with external accounter %s"
-msgstr ""
-
+#, python-format
 msgid "Search for %s(%s) from %s(scope=%s) returned no answer."
 msgstr ""
 
+#, python-format
 msgid "Problem adding LDAP entry (%s, %s)"
 msgstr ""
 
+#, python-format
+msgid "Problem deleting LDAP entry (%s)"
+msgstr ""
+
+#, python-format
 msgid "Problem modifying LDAP entry (%s, %s)"
 msgstr ""
-
-msgid "Problem deleting LDAP entry (%s)"
-msgstr ""
-
-msgid "Impossible to add printer %s"
-msgstr ""
-
-msgid "Prototype object %s not found in Quota Storage."
-msgstr ""
-
-msgid "Impossible to send mail to %s, error %s : %s"
-msgstr ""
-
-msgid "Unsupported reporter backend %s"
-msgstr ""
-
-msgid "Unable to compute size of %s in number of pages.\n"
-msgstr ""
-
-msgid "Job size : %i pages"    
-msgstr ""
-
-msgid "Cost on printer %s : %.2f"
-msgstr ""
-
-msgid "Invalid poor man's treshold %s"
-msgstr ""
-
-msgid ""
-"Your Print Quota account balance is Low.\n"
-"Soon you'll not be allowed to print anymore.\n"
-"Please contact the Print Quota Administrator to solve the problem."
-msgstr ""
-
-msgid "Print Quota Low"
-msgstr ""
-
-msgid "Your account balance : %.2f"
-msgstr ""
-
-msgid "Printer hostname undefined, set to 'localhost'"
-msgstr ""
-
-msgid "Printing system unknown, args=%s"
-msgstr ""
-
-msgid "Invalid policy %s for printer %s"
-msgstr ""
-
-msgid "User %s not registered in the PyKota system, applying external policy (%s) for printer %s"
-msgstr ""
-
-msgid "External policy %s for printer %s produced an error. Job rejected. Please check PyKota's configuration files."
-msgstr ""
-
-msgid "External policy %s for printer %s couldn't add user %s. Job rejected."
-msgstr ""
-
-msgid "Invalid option mailto %s for printer %s"
-msgstr ""
-